package org.helioviewer.jhv.gui.actions;

import java.awt.event.ActionEvent;
import java.awt.event.KeyEvent;

import javax.swing.AbstractAction;
import javax.swing.KeyStroke;

import org.helioviewer.jhv.gui.ImageViewerGui;
import org.helioviewer.viewmodel.view.LayeredView;

/**
 * Action to close the active layer.
 * 
 * @author Markus Langenberg
 */
public class CloseActiveLayerAction extends AbstractAction {

	private static final long serialVersionUID = 1L;
	
	/**
	 * Default constructor.
	 */
	public CloseActiveLayerAction() {
		super("Close Active Layer");
		putValue(ACCELERATOR_KEY, KeyStroke.getKeyStroke(KeyEvent.VK_W, KeyEvent.CTRL_MASK));
	}
	
	/**
	 * {@inheritDoc}
	 */
	public void actionPerformed(ActionEvent e) {
		ImageViewerGui img = ImageViewerGui.getSingletonInstance();
		img.getMainView().getAdapter(LayeredView.class).removeLayer(img.getImageSelectorPanel().getActiveChildFromLayeredView());
	}

}
