package org.helioviewer.jhv.gui.actions;

import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;

import org.helioviewer.jhv.gui.IconBank;
import org.helioviewer.jhv.gui.ImageViewerGui;
import org.helioviewer.jhv.gui.IconBank.JHVIcon;
import org.helioviewer.jhv.gui.controller.MainImagePanelMouseFocusController;

/**
 * Action to switch to focus mode.
 * 
 * @author Markus Langenberg
 */
public class SetFocusSelectionAction extends AbstractAction {

    private static final long serialVersionUID = 1L;

    /**
	 * Default constructor.
	 */
	public SetFocusSelectionAction() {
        super("Center", IconBank.getIcon(JHVIcon.FOCUS));
        putValue(SHORT_DESCRIPTION, "Track Solar Rotation");
    }

    /**
	 * {@inheritDoc}
	 */
	public void actionPerformed(ActionEvent e) {
        ImageViewerGui ivg = ImageViewerGui.getSingletonInstance();
        ivg.getMainImagePanel().getInputController().detach();
        ivg.getMainImagePanel().setInputController(new MainImagePanelMouseFocusController());
    }

}