package org.helioviewer.jhv.gui.components;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.Rectangle;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;

import javax.swing.SwingConstants;
import javax.swing.border.Border;
import org.helioviewer.jhv.gui.IconBank;
import org.helioviewer.jhv.gui.ImageViewerGui;
import org.helioviewer.jhv.gui.IconBank.JHVIcon;

public class collapsibleObservation extends JPanel implements MouseListener {
	/**
	 * 
	 */

	private static final long serialVersionUID = 1L;
	private JLabel lblTitle;
	private ObservationPanel bottomPane;

	private final Border normalBorder = BorderFactory.createCompoundBorder(
			BorderFactory.createEmptyBorder(2, 1, 2, 1), BorderFactory
					.createLineBorder(Color.LIGHT_GRAY, 1));
	private final Border highlightedBorder = BorderFactory
			.createCompoundBorder(BorderFactory.createEmptyBorder(1, 0, 1, 0),
					BorderFactory.createLineBorder(Color.GRAY, 2));

	public collapsibleObservation(ObservationPanel observationPanel) {
		super(new BorderLayout());
		addMouseListener(this);

		// Set name
		lblTitle = new JLabel("Add New Layer", IconBank.getIcon(JHVIcon.ADD),
				SwingConstants.LEFT);
		lblTitle.setFont(new Font(lblTitle.getFont().getFontName(), Font.PLAIN,
				14));
		lblTitle.setBorder(BorderFactory.createEmptyBorder(0, 1, 0, 0));
		lblTitle.addMouseListener(this);
		add(lblTitle, BorderLayout.CENTER);

		lblTitle.setPreferredSize(new Dimension(lblTitle.getWidth(), 23));
		// Add buttons
		JPanel buttonPanel = new JPanel(new FlowLayout(FlowLayout.LEFT, 1, 1));
		buttonPanel.setBorder(BorderFactory.createEmptyBorder(1, 0, 0, 0));
		add(buttonPanel, BorderLayout.EAST);

		JButton cmdDelete = new JButton();
		cmdDelete.addMouseListener(this);

		lblTitle.setBounds(new Rectangle(lblTitle.getWidth(), cmdDelete
				.getHeight()));

		lblTitle.setPreferredSize(new Dimension(Math.min(lblTitle
				.getPreferredSize().width + 5, ImageViewerGui.SIDE_PANEL_WIDTH
				- buttonPanel.getPreferredSize().width - 5), lblTitle
				.getPreferredSize().height));

		bottomPane = observationPanel;
		bottomPane.setVisible(true);
		bottomPane.addMouseListener(this);
		bottomPane.setOpaque(true);
		add(bottomPane, BorderLayout.SOUTH);
		this.setBorder(normalBorder);

	}

	public void mouseClicked(MouseEvent e) {

		if (bottomPane.isVisible()) {

			if (((ImageSelectorPanel) this.getParent()).getNumLayers() != 0) {
				collapse();
			}
		} else {
			explode();
		}

	}

	/**
	 * collapses the collapsibleObservation
	 */
	public void collapse() {
		bottomPane.setVisible(false);
		this.setBorder(normalBorder);
	}

	/**
	 * explodes the collapsibleObservation
	 */
	public void explode() {
		bottomPane.setVisible(true);
		this.setBorder(highlightedBorder);
	}

	public void mouseEntered(MouseEvent e) {
		// TODO Auto-generated method stub

	}

	public void mouseExited(MouseEvent e) {
		// TODO Auto-generated method stub

	}

	public void mousePressed(MouseEvent e) {
		// TODO Auto-generated method stub

	}

	public void mouseReleased(MouseEvent e) {
		// TODO Auto-generated method stub

	}

}
