package org.helioviewer.jhv.gui.components.statusplugins;

import org.helioviewer.viewmodel.changeevent.ChangedReason;
import org.helioviewer.viewmodel.view.View;

/**
 * Class represents a change reason when the active layer has changed.
 * 
 * <p>This reason is used for the graphical user interface only, since
 * the view chain itself does not define an active layer.
 * 
 * @author Markus Langenberg
 */
public class ActiveLayerChangedReason implements ChangedReason {

	// ///////////////////////////////////////////////////////////////
	// Definitions
	// ///////////////////////////////////////////////////////////////

	// memorizes the associated view
	private View view;

	// ///////////////////////////////////////////////////////////////
	// Methods
	// ///////////////////////////////////////////////////////////////
	
	/**
	 * Default constructor.
	 * 
	 * @param view
	 *            View which caused the change reason
	 */
	public ActiveLayerChangedReason(View view) {
	    this.view = view;
    }
	
	/**
	 * {@inheritDoc}
	 */
	public View getView() {
		return view;
	}

}
