package org.helioviewer.jhv.gui.dialogs;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;

import org.helioviewer.jhv.Settings;
import org.helioviewer.jhv.gui.IconBank;
import org.helioviewer.jhv.gui.ImageViewerGui;
import org.helioviewer.jhv.gui.interfaces.ShowableDialog;

public class MovieLinkInfoDialog extends JDialog implements ActionListener, ShowableDialog {

	private static final long serialVersionUID = 1L;
	
	private static ImageIcon linkIcon = IconBank.getIcon(IconBank.JHVIcon.MOVIE_UNLINK);
	private static ImageIcon unlinkIcon = IconBank.getIcon(IconBank.JHVIcon.MOVIE_LINK);
	
	private JCheckBox dontShowAgain;

	public MovieLinkInfoDialog() {
		super(ImageViewerGui.getMainFrame(), "Linking Movies", true);
		
		setLayout(new BorderLayout());
		
		JPanel mainPanel = new JPanel();
		mainPanel.setLayout(new BoxLayout(mainPanel, BoxLayout.PAGE_AXIS));
		mainPanel.setBorder(BorderFactory.createEmptyBorder(5, 5, 5, 5));
		add(mainPanel);
		
		mainPanel.add(new JLabel("To play multiple movies simultaneously, you have to link them\n"));
		mainPanel.add(new JLabel("by clicking on the small lock icon in the upper right corner\n"));
		mainPanel.add(new JLabel("of each movie panel you wish to link:"));
		
		JLabel label = new JLabel("Movies are linked", linkIcon, JLabel.TRAILING);
		label.setBorder(BorderFactory.createEmptyBorder(10, 30, 10, 10));
		mainPanel.add(label);
		
		label = new JLabel("Movies are not linked", unlinkIcon, JLabel.TRAILING);
		label.setBorder(BorderFactory.createEmptyBorder(0, 30, 10, 10));
		mainPanel.add(label);
		
		JPanel bottomPanel = new JPanel(new BorderLayout());
		bottomPanel.setBorder(BorderFactory.createEmptyBorder(5, 5, 5, 5));
		
		dontShowAgain = new JCheckBox("Do not show this message again", false);
		bottomPanel.add(dontShowAgain, BorderLayout.WEST);
		
		JButton cmdOk = new JButton("OK");
		cmdOk.addActionListener(this);
		bottomPanel.add(cmdOk, BorderLayout.EAST);
				
		add(bottomPanel, BorderLayout.SOUTH);
	}
	
	public void actionPerformed(ActionEvent arg0) {
		Settings.getSingletonInstance().setProperty("help.linkingmovies.show", Boolean.toString(!dontShowAgain.isSelected()));
		Settings.getSingletonInstance().save();
		dispose();
	}

	public void showDialog() {
		pack();
        setSize(getPreferredSize());
        setLocationRelativeTo(ImageViewerGui.getMainFrame());
        setVisible(true);
	}
}
