package org.helioviewer.jhv.internal_plugins;

import java.net.URI;
import java.net.URISyntaxException;

import org.helioviewer.jhv.internal_plugins.overlay.solarevents.SolarEventPlugin;
import org.helioviewer.viewmodelplugin.controller.PluginManager;
import org.helioviewer.viewmodelplugin.controller.PluginSettings;
import org.helioviewer.viewmodelplugin.overlay.OverlayContainer;
import org.helioviewer.viewmodelplugin.overlay.OverlayPlugin;

public class InternalOverlayPlugin extends OverlayPlugin implements InternalPlugin {

    /**
     * Default constructor.
     */
    public InternalOverlayPlugin() {
        try {
            pluginLocation = new URI("internal");
        } catch (URISyntaxException e) {
            e.printStackTrace();
        }
        
        addOverlayContainer(new SolarEventPlugin());
    }
    
    /**
     * {@inheritDoc}
     * <p>
     * Overrides the default method because the internal provided filters are
     * activated by default.
     */
    public void installPlugin() {
        for (OverlayContainer overlay : overlayContainerList) {
            overlay.setActive(PluginSettings.getSingeltonInstance().isOverlayInPluginActivated(pluginLocation, overlay.getOverlayClass(), true));
            overlay.setPosition(PluginSettings.getSingeltonInstance().getOverlayPosition(pluginLocation, overlay.getOverlayClass()));
            PluginManager.getSingeltonInstance().addOverlayContainer(overlay);
        }
    }
    
    /**
     * {@inheritDoc}
     * <p>
     * A description is not needed here because this plug-in is activated always
     * and will not be visible in the corresponding dialogs.
     */
    public String getDescription() {
        return null;
    }

    /**
     * {@inheritDoc}
     */
    public String getName() {
        return "internal overlays plugin";
    }
}
